// AppTechFlammableBuilding.hxx
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(APPTECHFLAMMABLEBUILDING_HXX__INCLUDED) // {
#define APPTECHFLAMMABLEBUILDING_HXX__INCLUDED

#include <iostream.h>
#include "objects.hxx"


namespace Rescue
{
	/////////////////////////////////////////////////////////////////////////
	// AppTechFlammableBuilding

	class Building;
	class AppTechObjectPool;
	class AppTechFlammableBuilding : public Building
	{
	private:
		
	protected:
		AppTechObjectPool* m_owner;
		
	public:
		virtual void input(long int, Rescue::ObjectPool &, Rescue::Input &, long int);
		std::vector<XY> zahyo; // Coordinate of building
		XY ajushin;	// Center of gravity
		double ascl;	// Scale (square root of area)
		S32 k2;   // M_buildingCode_mkdat (11 woodwork, 21 fire prevention, 31 fire-resistance) - (1, 2, 3) it returns
		S32 m_buildingCode_mkdat; // M_buildingCode (0 woodwork, 1 fire prevention, 2 fire-resistance) - (11, 21, 31) it returns
		S32 m_buildingCode_trainning;  // M_buildingCode_mkdat (11 woodwork, 21 fire prevention, 31 fire-resistance) - (1, 2, 3) it returns

		double m_dblBuildingAreaTotal; // buildingAreaTotal() /	100	
		double m_dblBuildingAreaGround; // buildingAreaGround() / 100		
		double areaTotal() const {
			return m_dblBuildingAreaTotal;
		}
		double areaGround() const {
			return m_dblBuildingAreaGround;
		}
		void setAreaTotal(S32 time /* dummy */, double value) {
			m_dblBuildingAreaTotal = value;
		}
		void setAreaGround(S32 time /* dummy */, double value) {
			m_dblBuildingAreaGround = value;
		}
		
		class rinsetu {
		public:
			AppTechFlammableBuilding *fb;
			double min_dist;
			double start_angle;
			double end_angle;

			rinsetu(AppTechFlammableBuilding* p,
				double md = -1,	
				double sa = 0,
				double ea = 0) {
				fb = p;
				min_dist = md;
				start_angle = sa;
				end_angle = ea;
			}
			rinsetu(const rinsetu& ri) {
				fb = ri.fb;
				min_dist = ri.min_dist;
				start_angle = ri.start_angle;
				end_angle = ri.end_angle;
			}
		};
		typedef std::vector<rinsetu> rinsetu_v;
		rinsetu_v nrinsetu;

		class ensho {
		public:
			double	dp;             // Combustion ratio  p
			double	tpp;            // Time ratio t
			S32	on_time;        // Ignition time (second)
			double	p;              // Cumulative combustion ratio p (t)
			double	syobo_sum; 	// Accumulation fire fighting ratio
			S32	timeRank_f_Updated;
			S32	rank_f_bak;	// Building combustion state remark-----------------------
			S32	rank_f;		// Building combustion state remark-----------------------
						//	0: Not yet ignition
						//      1: (Time ratio in the midst of burning 0-0.33)
						//	2: (Time ratio in the midst of burning 0.33-0.67)
						//	3: (Time ratio in the midst of burning 0.67-1.0)
 						// 	4: Compacting
			S32	timeRank_w_Updated;
			S32	rank_w_bak;     // Building compacting state remark-----------------------
			S32	rank_w;	        // Building compacting state remark-----------------------
                                                //	0: Not yet compacting
                                                //      1: Part burning (under 20%)
                                                // 	2: Partial loss by fire (under 70% of 20% or more)
                                                // 	3: Total destruction (70% or more)
			double	rrf;		// Cumulative spread of fire influence quantity
			double	gfr_ttl;        // Entire combustion weight
			double	gfr_rst;        // Remains combustion weight
			double  a2_lost;        // Burnt architectural area
			S32	ikiken;         // Building degree of risk flag
			S32	itoukai;        // Building collapse flag

			ensho() {
				dp = 0;
				tpp = 0;
				on_time = 0;
				p = 0;
				syobo_sum = 0;
				rank_f = 0;
				rank_w = 0;
				rrf = 0;
				gfr_ttl = 0;
				gfr_rst = 0;
				a2_lost = 0;
				ikiken = 0;
				itoukai = 0;
				timeRank_w_Updated = -1;
				timeRank_f_Updated = -1;
			}
			void setRankF(const S32 f, const S32 tnow) { rank_f = f; timeRank_f_Updated = tnow; }
			void setRankW(const S32 w, const S32 tnow) { rank_w = w; timeRank_w_Updated = tnow; }
		};
		ensho fire;
	  
		class log {
		public:
			S32 structid;
			S32 start;    // ! Fire break-out time
			S32 time1;    // ! Combustion time 1
			S32 time2;    // ! Combustion time 2
			S32 aend;     // ! Finish time
			S32 fstat;    // ! Combustion state flag
			
			log(){
				start = time1 = time2 = aend = -1;
			}
		};
		log fire_log;

		class tmp {
		public:
			S32 tutu;
			double water;

			tmp(){
				tutu = 0;
				water = 0;
			}
		};
		tmp now;

		double rft;
		double rxt;
		virtual ~AppTechFlammableBuilding();
		AppTechFlammableBuilding(AppTechObjectPool* pool);

		int tikudat_index;

		void jushin_cal();
		void scl_cal();
		double men_cal();
//		void menseki_cal();
		void kashi();

		void near(std::vector<rinsetu>& nrin);
		void pickup(std::vector<rinsetu>& nrin);

		void angle(rinsetu &);
//		void arinsetu();
		void dataread();

	private:
		AppTechFlammableBuilding(const AppTechFlammableBuilding& source);
		AppTechFlammableBuilding& operator= (const AppTechFlammableBuilding& rhs);
		bool operator== (const AppTechFlammableBuilding& rhs) const;
	};
	
	/////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#ifdef NDEBUG
#  include "AppTechFlammableBuilding.inl"
#endif

#endif // } !defined(FLAMMABLEBUILDING_HXX__INCLUDED)

