// parameters.hxx
//
/////////////////////////////////////////////////////////////////////////////

/** The parameter which is managed with Config is defined */

//P(type, name, initial value)


// Kernel generates random IDs for units in each simulation.
P(bool, random_IDs,                     false)          // NOT TESTED.

// KA_HEAR_TELL and KA_HEAR_SAY are added to the RoboCup Rescue protocol.
P(bool, additional_hearing,             false)          // NOT TESTED.

// The maximum power of one extinguish action. (-1 to unlimit)
P(int,  max_extinguish_power_sum,       -1)             // NOT TESTED.

// The maximum extinguish power for each nozzle. (-1 to unlimit)
P(int,  max_extinguish_power,           1000)           // NOT TESTED.

// The maximum number of nozzles for one extinguish action. (-1 to unlimit)
P(int,  max_nozzles,                    -1)             // NOT TESTED.






// send the fieryness of the far fired buildings only when it is different from the value sent before.
P(bool, send_far_fire_changed_only,         false)

// use gettimeofday and sleep rather than signals.
P(bool, use_gettimeofday,                   false)

// The speed[mm/step] of the cognition of fire.
// An agent can discover a fire within a distance
//   fire_cognition_spredding_speed * (steps from the start of burnup)
// -1 to invalidate this feature.
P(int, fire_cognition_spredding_speed,      -1)

P(bool, simulate_tank_quantity,             false)

P(int, tank_quantity_recovery_on_refuge,    0)

P(int, tank_quantity_maximum,               15000)


// Ignore the nozzle position parameter of the AK_EXTINGUISH;
// the nozzle is placed at the position where the fire brigade is.
// max_fire_hose_length is ignored if this parameter is true.
P(bool, ignore_nozzle_position,     false)

// The repairCost of a road is given by
// (block * roadLength + (area_per_repair_cost - 1)) / area_per_repair_cost.
//          (0 means compatible with the old specification.)
P(int,  area_per_repair_cost,       0)      // e.g. 10000 * 2000

// Rounds down water quantity of AK_EXTINGUISH to meter^3.
P(bool, round_down_quantity,        true)

// Accepts that fire brigades use multiple nozzles for AK_EXTINGUISH.
P(bool, accept_multiple_nozzles,    false)

// Accepts that rescue teams rescue near agents.
P(bool, near_agents_rescuable,      false)

// Accepts that rescue teams rescue near agents.
P(bool, miscsimulator_supports_load,    true)

// Far fired buildings are invisible to agents in the first 'steps_far_fire_invisible' steps.
P(int,  steps_far_fire_invisible,   0)

// Agents can do nothing in the first 'steps_agents_freezed' steps.
P(int,  steps_agents_freezed,       2)

// Notify the initial positions of all agents to agents.
P(bool,  notify_initial_position,   true)

// Notify the position history properties of all agents to agents.
P(bool,  notify_position_history,   true)

// For buildings outside vision, notify only fieryness property.
P(bool,  notify_only_fire_for_far_buildings,    false)

// notify every steps property that are not changed in a simulation.
P(bool,  notify_unchangeable_informaion,        true)


// Stop the simulation safely if kbhit().
P(bool, interactive_stop,           false)


// wait until the enter key is pressed before the start of the game.
P(bool, wait_before_start,  false)

// Gis typical port number
// The public port number of GIS.  The kernel try to connect to this port firstly.
P(int,  gis_port,           6001)

// Kernl typical port number
// The public port number of Kernel.  The other modules try to connect to this port firstly.
P(int,  port,               6000)

//Proxy typical port number
P(int,  proxy_port,         6000)

//Basic unit of processing time of simulation
// The time of one simulation step.
P(int,  step,               1000)

// Simulation the number of steps which are done
P(int,  period,             72 * 60)    // 72 hours

// Maximum size of the UDP packet which is transmitted
// The maximum size of a packet the module sends (not the maximum size receivable).
P(int,  send_udp_size,      1500/*Ether MTU*/ - 20/*IP Header*/ - 8/*UDP Header*/)

// Continuing the UDP packet, when transmitting, just between it can be less crowded number of milli-seconds
// The interval in milliseconds of sending packets continuously.
P(int,  send_udp_wait,      30)

// Standard vision
// The eyesight in millimeters.
P(int,  vision,             10000)      // 10 meters

// The millmeters voices reach.
P(int,  voice,              30000)      // 30 meters


P(int,  block_stamina_denominator,      0)


//SAY message maximum size
// The maximum messages size of SAY and TELL command.
P(int,  say_max_bytes,      512)

P(int,  max_fire_hose_length,   1000)     // 1 meter

// the maximum length to an extinguishable building.
P(int,  max_extinguish_length,   30000)     // 30 meters


//When extending the hose, about which it can extend in one minute?
// The length of a fire hose that a fire company can stretch per second.
P(int,  stretch_length,     512)

// If the number of masses of the mesh which is used with RescueObjectPool (1000 you divide in the 1000x1000 mesh)
P(int,  mesh_size,          1000)

// Name of log
P(string,   textlogname_gis,                    "")
P(string,   textlogname_samplegis,              "")
P(string,   textlogname_kernel_publicsock,      "")
P(string,   textlogname_kernel_gissock,         "")
P(string,   textlogname_kernel_simulatorsock,   "")
P(string,   textlogname_kernel_agentsock,       "")
P(string,   textlogname_miscsimulator,          "")
P(string,   textlogname_samplesimulator,        "")
P(string,   textlogname_samplecivilian,         "")
P(string,   textlogname_logplayer,              "")
P(string,   textlogname_proxy,                  "")
P(string,   textlogname_proxy_kernelsock,       "")
P(string,   textlogname_proxy_publicsock,       "")
// The name of the log that the logplayer can play.
P(string,   logname,                            "")



// The followings are for the fire simulator.

// [Parameters]
// Burning falling time (woodwork, fire prevention and fire-resistance)
P(int,  TSL1,   50)
P(int,  TSL2,   80)
P(int,  TSL3,   120)

// Flame blowing out time (woodwork, fire prevention and fire-resistance)
P(int,  TS11,   15)
P(int,  TS12,   60)
P(int,  TS13,   60)

// Time ratio C to mature stage
P(double,   PRC,    -0.4)

// Tilted factor of å function
P(double,   PRA,    7.8)

// Wind velocity correction coefficient
P(double,   PRV1,   -0.4)

// Weight of classified by building structure
P(double,   CWW1,   1)
P(double,   CWW2,   0.7)
P(double,   CWW3,   0.02)

// Standard 1F area (m2)
P(double,   STA1,   100.0)

// Standard preparing deck area (m2)
P(double,   STAL,   100.0)

// Standard 1F building height (m)
P(double,   STF1,   3)

// Standard fire load (Kg/m2)
P(double,   STQW,   120.0)

// Standard prospect angle
P(double,   STS,    2.94)

// Standard distance (m)
P(double,   STD,    1.0)

// Wooden building ignition reference level (cumulative spread of fire influence quantity, unit time spread of fire influence quantity and unit time 
//maximum spread of fire influence quantity)
P(double,   CTW1,   0.02)
P(double,   CTW2,   0.015)
P(double,   CTW3,   0.01)

//  T time it cuts, (second)
P(int,  DT, 60)


#if 0
// [System] XXX: Using, increase it is.
// The communication log is written out in the file, (ON), it does not write out, (OFF)
P(string,   WRITELOG,   "OFF")

// The communication log is written out in the picture, (ON), it does not write out, (OFF)
P(string,   DISPLOG,    "ON")
#endif



// The followings are for the miscsimulator.

// Random Seed
P(int,     misc_random_seed, -1)

// Seismic intensity distribution data
P(string,  shindopolydata,              "shindopolydata.dat")
P(string,  galpolydata,                 "galpolydata.dat")

// The size of Dice
P(int,     magnitude_dice, 10000)

// Parameter k of the damage advance function of DamageBury * damage^2 + l + mutation
// parameter for progress DamageBury function
P(double,  parameter_damage_bury_k,       0.00055)
P(double,  parameter_damage_bury_l,       0.1)
P(double,  probability_mutation_damage_bury,     0.1) // 

// Parameter k of the damage advance function of DamageBroken * damage^2 + l + mutation
// parameter for progress DamageBroken function
P(double,  parameter_damage_broken_k,       0.00015)
P(double,  parameter_damage_broken_l,       0.03)
P(double,  probability_mutation_damage_broken,     0.1)

// Parameter k of the damage advance function of DamageFiery * damage^2 + l + mutation
// parameter for progress DamageFiery function
P(double,  parameter_damage_fiery_k,       0.00015)
P(double,  parameter_damage_fiery_l,       0.03)
P(double,  probability_mutation_damage_fiery,     0.1)

// Parameter k of the damage advance function of DamageBlock * damage^2 + l + mutation
// parameter for progress DamageBlock function
P(double,  parameter_damage_block_k,       0.00015)
P(double,  parameter_damage_block_l,       0.03)
P(double,  probability_mutation_damage_block,     0.1)

// Extent of house collapse
P(int,     brokenness_partial_collapsed,     25)
P(int,     brokenness_half_collapsed,        50)
P(int,     brokenness_all_collapsed,         100)

// Degree of burying (degree of buried _ structural _ degree of collapse _ seismic intensity _)
//   Woodwork and part damage
P(int,     buriedness_wood_partial_5seismic, 10)  // less than seismic 5
P(int,     buriedness_wood_partial_6seismic, 10)  // seismic 6
P(int,     buriedness_wood_partial_7seismic, 10)  // seismic 7
P(int,     buriedness_wood_partial_8seismic, 10)  // more than seismic 7
//   Woodwork and half collapse
P(int,     buriedness_wood_half_5seismic, 60)
P(int,     buriedness_wood_half_6seismic, 60)
P(int,     buriedness_wood_half_7seismic, 60)
P(int,     buriedness_wood_half_8seismic, 60)
//   Woodwork and complete destruction
P(int,     buriedness_wood_all_5seismic, 120)
P(int,     buriedness_wood_all_6seismic, 120)
P(int,     buriedness_wood_all_7seismic, 120)
P(int,     buriedness_wood_all_8seismic, 120)

//   Steel-frame structure, part damage
P(int,     buriedness_steel_partial_5seismic, 0)  // less than seismic 5
P(int,     buriedness_steel_partial_6seismic, 0)  // seismic 6
P(int,     buriedness_steel_partial_7seismic, 0)  // seismic 7
P(int,     buriedness_steel_partial_8seismic, 0)  // more than seismic 7
//   Steel-frame structure, half collapse
P(int,     buriedness_steel_half_5seismic, 0)
P(int,     buriedness_steel_half_6seismic, 0)
P(int,     buriedness_steel_half_7seismic, 0)
P(int,     buriedness_steel_half_8seismic, 0)
//   Steel-frame structure, complete destruction
P(int,     buriedness_steel_all_5seismic, 0)
P(int,     buriedness_steel_all_6seismic, 0)
P(int,     buriedness_steel_all_7seismic, 0)
P(int,     buriedness_steel_all_8seismic, 0)

//   Concrete structure, part damage
P(int,     buriedness_rc_partial_5seismic, 0)
P(int,     buriedness_rc_partial_6seismic, 0)
P(int,     buriedness_rc_partial_7seismic, 0)
P(int,     buriedness_rc_partial_8seismic, 0)
//   Concrete structure, half collapse
P(int,     buriedness_rc_half_5seismic, 0)
P(int,     buriedness_rc_half_6seismic, 0)
P(int,     buriedness_rc_half_7seismic, 0)
P(int,     buriedness_rc_half_8seismic, 0)
//   Concrete structure, complete destruction
P(int,     buriedness_rc_all_5seismic, 0)
P(int,     buriedness_rc_all_6seismic, 0)
P(int,     buriedness_rc_all_7seismic, 0)
P(int,     buriedness_rc_all_8seismic, 0)


// Being killed or being injured ratio (structural _ injury _ seismic intensity)
// occurrence rate
P(double,     rate_wood_death_5seismic,     0.0)
P(double,     rate_wood_death_6seismic,     0.0024917)
P(double,     rate_wood_death_7seismic,     0.0092440)
P(double,     rate_wood_death_8seismic,     0.0200000)  // Provision: There is no statistical data

P(double,     rate_wood_serious_5seismic,  0.0)
P(double,     rate_wood_serious_6seismic,  0.0027906)
P(double,     rate_wood_serious_7seismic,  0.0096705)
P(double,     rate_wood_serious_8seismic,  0.0200000)  // Provision: There is no statistical data

P(double,     rate_wood_slight_5seismic,   0.0)
P(double,     rate_wood_slight_6seismic,   0.0080275)
P(double,     rate_wood_slight_7seismic,   0.0258145)
P(double,     rate_wood_slight_8seismic,   0.300000)  // Provision: There is no statistical data

P(double,     rate_steel_death_5seismic,   0.00000535)
P(double,     rate_steel_death_6seismic,   0.00012521)
P(double,     rate_steel_death_7seismic,   0.0007503)
P(double,     rate_steel_death_8seismic,   0.005) // Provision: There is no statistical data 

P(double,     rate_steel_serious_5seismic,   0.0001275427)
P(double,     rate_steel_serious_6seismic,   0.000279061)
P(double,     rate_steel_serious_7seismic,   0.0096705)
P(double,     rate_steel_serious_8seismic,   0.03) // Provision: There is no statistical data 

P(double,     rate_steel_slight_5seismic,    0.0005437693)
P(double,     rate_steel_slight_6seismic,    0.00798749)
P(double,     rate_steel_slight_7seismic,    0.0257665)
P(double,     rate_steel_slight_8seismic,    0.1) // Provision: There is no statistical data 

P(double,     rate_rc_death_5seismic,   0.00000535)
P(double,     rate_rc_death_6seismic,   0.00012521)
P(double,     rate_rc_death_7seismic,   0.0007503)
P(double,     rate_rc_death_8seismic,   0.005) // Provision: There is no statistical data 

P(double,     rate_rc_serious_5seismic,   0.0001275427)
P(double,     rate_rc_serious_6seismic,   0.000279061)
P(double,     rate_rc_serious_7seismic,   0.0096705)
P(double,     rate_rc_serious_8seismic,   0.03) // Provision: There is no statistical data 

P(double,     rate_rc_slight_5seismic,    0.0005437693)
P(double,     rate_rc_slight_6seismic,    0.00798749)
P(double,     rate_rc_slight_7seismic,    0.0257665)
P(double,     rate_rc_slight_8seismic,    0.1) // Provision: There is no statistical data 

// Ψ
P(double,     rate_bury_wood_5seismic,    0.00001)
P(double,     rate_bury_wood_6seismic,    0.0292)
P(double,     rate_bury_wood_7seismic,    0.1)
P(double,     rate_bury_wood_8seismic,    0.2) // There is no statistical data

P(double,     rate_bury_steel_5seismic,   0.0)
P(double,     rate_bury_steel_6seismic,   0.001782)
P(double,     rate_bury_steel_7seismic,   0.0040)
P(double,     rate_bury_steel_8seismic,   0.008) // There is no statistical data

P(double,     rate_bury_rc_5seismic,   0.0)
P(double,     rate_bury_rc_6seismic,   0.001782)
P(double,     rate_bury_rc_7seismic,   0.0040)
P(double,     rate_bury_rc_8seismic,   0.008) // There is no statistical data 

// When being buried the probability which receives the damage (these sumation <= 1.0)
P(double,    prob_bury_slight,        0.3)
P(double,    prob_bury_serious,       0.5)
P(double,    prob_bury_dying,         0.1)

// The probability which receives the damage inside the building which spreads (these sumation <= 1.0)
P(double,    prob_fiery_slight,       0.3)
P(double,    prob_fiery_serious,      0.5)
P(double,    prob_fiery_dying,        0.1)  

// The probability which receives the damage with road block (these sumation <= 1.0)
P(double,    prob_block_slight,       0.3)
P(double,    prob_block_serious,      0.5)
P(double,    prob_block_dying,        0.1)  

// The damage which is given to Civilian (damage for Civilian)
// The damage due to collapse
 // Intactness
P(int,       damage_broken_unhurt,      0)
// Flesh wound
P(int,       damage_broken_slight,      1)
// The serious injury
P(int,       damage_broken_serious,     5)
// Dying
P(int,       damage_broken_dying,     500)
// Death
P(int,       damage_broken_death,      10000)


// The damage due to burying
// Intactness
P(int,       damage_bury_unhurt,      0)
// Flesh wound
P(int,       damage_bury_slight,      5)
// The serious injury
P(int,       damage_bury_serious,     20)
// Dying
P(int,       damage_bury_dying,       500)
// Death
P(int,       damage_bury_death,        10000)

// The damage due to fire
// Intactness
P(int,       damage_fiery_unhurt,      0)
// Flesh wound
P(int,       damage_fiery_slight,     50)
// The serious injury
P(int,       damage_fiery_serious,   100)
// Dying
P(int,       damage_fiery_dying,     500)
// Death
P(int,       damage_fiery_death,    10000)

// The damage due to road block
// Intactness
P(int,       damage_block_unhurt,      0)
// Flesh wound
P(int,       damage_block_slight,     3)
// The serious injury
P(int,       damage_block_serious,    8)
// Dying
P(int,       damage_block_dying,     15)
// Death
P(int,       damage_block_death,    10000)

// The magnification ratio for the damage which is given to Civilian
// It applies to the agent other than Civilian
// for AmbulanceTeam
P(double,    magnification_damage_bury_ambulance,      0.2)
P(double,    magnification_damage_broken_ambulance,      0.2)
P(double,    magnification_damage_fiery_ambulance,      0.2)
P(double,    magnification_damage_block_ambulance,      0.2)
// for PoliceForce
P(double,    magnification_damage_bury_police,      0.2)
P(double,    magnification_damage_broken_police,      0.2)
P(double,    magnification_damage_fiery_police,      0.2)
P(double,    magnification_damage_block_police,      0.2)
// for FireBrigade
P(double,    magnification_damage_bury_firebrigade,      0.2)
P(double,    magnification_damage_broken_firebrigade,      0.2)
P(double,    magnification_damage_fiery_firebrigade,      0.2)
P(double,    magnification_damage_block_firebrigade,      0.2)

